#ifndef __ICONS_H
#define __ICONS_H

#include <shellapi.h>

// ----Classes---------------------------------------------------------------------------------
//
_CLASSDEF(TMHIconSelListBox)
_CLASSDEF(TMHIconSelDlg)

//	Declare TMHIconSelListBox, a TListBox descendant-------------------------------------------
//
class TMHIconSelListBox : public TListBox
{
  private:

	WORD 			IconHeight,		//	Height of icon
					IconWidth;		//	Width  ...

  public:

	TMHIconSelListBox				( PTWindowsObject AParent, int ResourceId, PTModule AModule = NULL );

	inline int 		GetHeight		() { return IconHeight;  }
	inline int 		GetWidth		() { return IconWidth;   }
	inline void 	SetHeight		( int TheHeight ) { IconHeight = TheHeight; }
	inline void 	SetWidth		( int TheWidth  ) { IconWidth  = TheWidth;  }

};

//	Declare TMHIconSelDlg, a TDialog descendant------------------------------------------------
//
class TMHIconSelDlg : public TDialog
{

  private:

	PTMHIconSelListBox 	ListBox;				//	Listbox with icons
   	PTEdit        		FileName;				//	File containing icons

	char			   *TheSourceFile;			//	Values passed into dialog
    int				   *TheIcon;				//	...

   	char			    SourceFile[MAXPATH];	//	Name of sourcefile
   	int					Icon;					//	# of current icon in file

	DWORD 				ColorHighlight,
    					ColorHighlightText,
						ColorWindow,
                        ColorWindowText;

	int 				GetIconCount		();
	BOOL 				FillIconList		();
	void 				ClearIconList		();
	void 				ResetIconList		();

  public:

	TMHIconSelDlg	( PTWindowsObject AParent, char *ASourceFile, int &AnIcon );

	virtual void  			SetupWindow		();

	virtual void 			ShutDownWindow	( int ARetValue );
	virtual void 			ShutDownWindow	();

	virtual void  			WMMeasureItem	( RTMessage Msg ) = [ WM_FIRST + WM_MEASUREITEM		];
	virtual void  			WMDrawItem		( RTMessage Msg ) = [ WM_FIRST + WM_DRAWITEM		];

	virtual void  			Ok				( RTMessage Msg ) = [ ID_FIRST + IDOK				];
	virtual void			HandleFileName	( RTMessage Msg ) = [ ID_FIRST + idd_IcoSelText   	];
	virtual void  			Browse			( RTMessage Msg ) = [ ID_FIRST + idd_IcoSelBrowse 	];
	virtual void  			HandleListBox	( RTMessage Msg ) = [ ID_FIRST + idd_IcoSelList   	];

};

#endif
