//	Standard includes-------------------------------------------------------------------------
//
#include <owl.h>
#include <filedial.h>
#include <bwcc.h>

#include <static.h>
#include <edit.h>

#include <alloc.h>
#include <assert.h>
#include <dir.h>
#include <stdarg.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

//	Personal defines--------------------------------------------------------------------------
//
#define	scope
#define	MakeIntRes(x)	MAKEINTRESOURCE(x)

//	MHlist includes---------------------------------------------------------------------------
//
#include "rc_main.h"

#include "od.h"
#include "group.h"

//	Basic classes-----------------------------------------------------------------------------
//
_CLASSDEF(TMHlistApp)
_CLASSDEF(TMHlistDlg)
_CLASSDEF(TMHItemDlg)

//	Global data-------------------------------------------------------------------------------
//
extern PTMHlistApp		TheApp;
extern PTMHlistDlg		TopWnd;

//	Declare TMHlogonApp, a TMHApplication descendant------------------------------------------
//
class _EXPORT TMHlistApp :public TApplication
{

  private:

	PTMHGroups			List;			//	SortedArray

  public:

	//	Constructor
	//
	 TMHlistApp			( LPSTR AName, HINSTANCE AnInstance, HINSTANCE APrevInstance, LPSTR ACmdLine, int ACmdShow );

	//	Overridden OWL functions
	//
	virtual	void 		InitMainWindow	();

};

//	Declare TMHlistDlg, a TDialog descendant--------------------------------------------------
//
class _EXPORT TMHlistDlg :public TDialog
{
  private:

	PTMHGroups			List;		//	SortedArray
	PTMHGroupListBox	ListBox;	//	ListBox

	void				HandleSelection	();

  public:

	//	Con- and Destructor
	//
	 TMHlistDlg			( PTMHGroups TheList );
	~TMHlistDlg			();

  protected:

	//	Setup
    //
	virtual LPSTR 		GetClassName	() { return "BorDlgMHlist"; }
	virtual void 		GetWindowClass	( WNDCLASS& WndClass );
	virtual void		SetupWindow		();

	//	ListBox
    //
	virtual void  		WMMeasureItem	( RTMessage Msg ) = [ WM_FIRST + WM_MEASUREITEM	  ];
	virtual void  		WMCompareItem	( RTMessage Msg ) = [ WM_FIRST + WM_COMPAREITEM	  ];
	virtual void  		WMDrawItem		( RTMessage Msg ) = [ WM_FIRST + WM_DRAWITEM	  ];

	//	Action
	//
	virtual void		Add				( RTMessage Msg ) = [ ID_FIRST + idd_BorAdd       ];
	virtual void		Change			( RTMessage Msg ) = [ ID_FIRST + idd_BorChg       ];
	virtual void		Delete			( RTMessage Msg ) = [ ID_FIRST + idd_BorDel       ];
	virtual void		ListHandler		( RTMessage Msg ) = [ ID_FIRST + idd_Items 		  ];
	virtual void		Ok				( RTMessage Msg ) = [ ID_FIRST + IDOK             ];
	virtual void		SysCommand		( RTMessage Msg ) = [ WM_FIRST + WM_SYSCOMMAND    ];

};

//	Declare TMHItemDlg, a TDialog descendant--------------------------------------------------
//
class _EXPORT TMHItemDlg :public TDialog
{
  private:

	PTMHGroups				Groups;			//	List of groups
	PTMHGroup				Group;			//	Current group
	BOOL					NewGroup;		//	New flag

	PTEdit					Description;	//	Group name

  public:

	//	Constructor
	//
	 TMHItemDlg		( PTMHGroup TheGroup, PTMHGroups TheGroups, int ATitle, PTWindowsObject AParent );

  protected:

	//	Setup
    //
	virtual void		SetupWindow		();

	//	Action
	//
	virtual void		Ok				( RTMessage Msg ) = [ ID_FIRST + IDOK      	 	];
	virtual void		Browse			( RTMessage Msg ) = [ ID_FIRST + idd_ItemBrowse	];

};

//	Support functions-------------------------------------------------------------------------
//
//	window.cpp
//
void mh_CenterPopup		( HWND hWnd, HWND hParentWnd = NULL );

//	res_util.cpp
//
void _EXPFUNC _FAR 	mh_MakeResStr	( const char *ResString, char *Buffer, int BufSize );
void _EXPFUNC _FAR 	mh_ResourceText	( PTStatic Control, ... );
void _EXPFUNC _FAR 	mh_ResourceText	( PTWindowsObject Window, ... );
