#ifndef __OD_H
#define __OD_H

//	TClassLib
#include <sortarry.h>
#include <listbox.h>

// ----Classes--------------------------------------------------------------------------------

_CLASSDEF(TODSortedArray)
_CLASSDEF(TODSortable)
_CLASSDEF(TODListBox)

//	Declare TODSortedArray, a SortedArray descendant------------------------------------------
//
class TODSortedArray : public SortedArray
{
  private:

  	PTListBox						ListBox;

  public:

	//	Constructor
	//
	TODSortedArray					( int uppper, int lower = 0, sizeType aDelta = 0 );

	//	Listbox handling
	//
    virtual void					RegisterListBox		( PTODListBox TheListBox );
	virtual void					UnregisterListBox	();

	//	Add/Remove
	//
	virtual void 					add					( Object _FAR & toAdd );
	virtual void 					detach				( int loc, DeleteType dt = NoDelete );
	virtual void 					detach				( Object _FAR & toDetach, DeleteType dt = NoDelete );

	//	TClassLib
	//
	inline	virtual classType 		isA					() const	{ return 0; 				}
	inline	virtual char 		   *nameOf				() const	{ return "TODSortedArray"; 	}
	inline	virtual hashValueType 	hashValue			() const	{ return 0; 				}

};

//	Declare TODSortable, a Sortable descendant------------------------------------------------
//
class TODSortable: public Sortable
{

  public:

	//	Access data
	//
    inline	virtual const char	   *GetText				() const { return ""; } 

	//	TClassLib
	//
	inline	virtual classType 		isA					() const	{ return 0; 				}
	inline	virtual char 		   *nameOf				() const	{ return "TODSortable"; 	}
	inline	virtual hashValueType 	hashValue			() const	{ return 0; 				}
};

//	Declare TODListBox, a TListBox descendant-------------------------------------------------

class TODListBox : public TListBox
{
  protected:

    WORD			Height;					//	Height of line
	DWORD 			ColorHighlight,			//	Colors
    				ColorHighlightText,
					ColorWindow,
                    ColorWindowText;

  public:

	TODListBox		( PTWindowsObject AParent, int ResourceId, PTModule AModule = NULL );

	//	ListBox
	//
	virtual void	Display					( LPDRAWITEMSTRUCT DIS, PTODSortable Item );
	virtual void	HandleWMMeasureItem		( LPMEASUREITEMSTRUCT MIS );
	virtual int		HandleWMCompareItem		( LPCOMPAREITEMSTRUCT CIS );
	virtual void 	HandleWMDrawItem		( LPDRAWITEMSTRUCT    DIS );

};

#endif

