//      MHlist v2.0			Segment 3
//
//		ABOUT.CPP			About dialog (generic)
//
//		(C)opyright 1992	by Matthias Hansen. Alle Rechte vorbehalten.
//
//
#pragma  option -zC_TEXT_ABOUT
#include "mhlist.h"
#pragma  hdrstop

#include "about.h"
#include <ver.h>

// ----TMHAboutDialog------------------------------------------------------------Constructor---

TMHAboutDialog::TMHAboutDialog( PTWindowsObject AParent ) :TDialog( AParent, dlg_About)
{
	DWORD				InfoSize,				//	Size of version information
    					InfoHandle;				//	Handle to version information
	char				Filename[ 80 ],			//	Calling exe-filename
    				   *Buffer;					//	Buffer for version info

	//	Parent is required!
	//
    assert( Parent != NULL );

	//	Save application
	//
	App = Parent->GetApplication();

	//	Assume failure
	//
	strcpy( VersionStr, "?" );

	//	Retrieve version info from resource
	//
	//	a) Get filename
	//
	GetModuleFileName( App->hInstance, Filename, sizeof(Filename)-1 );

	//	b) Locate version resource and allocate buffer
	//
	if ( ( InfoSize = GetFileVersionInfoSize( Filename, &InfoHandle ) ) != NULL &&
		 ( Buffer   = new char[ (unsigned int)InfoSize ]              ) != NULL ) {

		//	c) Load version info
		//
		if ( GetFileVersionInfo( Filename, InfoHandle, InfoSize, Buffer ) ) {

			DWORD FAR  *TranslationInfo;	//	Ptr to translation info
			UINT		TranslationSize;	//	Sizeof translation info
            char		Translation[ 80 ];	//	Translated request

			//	Retrieve translation info
			//
			VerQueryValue( Buffer, "\\VarFileInfo\\Translation", (VOID FAR* FAR*)&TranslationInfo, &TranslationSize );

			//	Retrieve file version string
			//
			if( TranslationSize ) {

				UINT		LanguageID = LOWORD( *TranslationInfo ),
                			CharsetID  = HIWORD( *TranslationInfo );

				//	Create string
                //
				sprintf( Translation, "\\StringFileInfo\\%04x%04x\\FileVersion", LanguageID, CharsetID );

				//	Retrieve info
				//
				VerQueryValue( Buffer, Translation, (VOID FAR* FAR*)&TranslationInfo, &TranslationSize );

				//	Copy to string
				//
				strncpy( VersionStr, (LPCSTR)TranslationInfo, sizeof(VersionStr)-1 );
				VersionStr[ sizeof(VersionStr)-1 ] = 0;

				}

			}

		//	Free buffer
		//
        delete Buffer;

		}  
				 
	//	Create Version control
	//
	Version = new TStatic( this, idd_AboutVersion, 60 );

}

// ----SetupWindow--------------------------------------------------------------public void---

void TMHAboutDialog::SetupWindow()
{
	char				Buffer[ 30 ];

	//	Action
	//
	TDialog::SetupWindow();

	//	Center Dialog
	//
	mh_CenterPopup( HWindow, Parent->HWindow );

	//	Load title
	//
	LoadString( GetApplication()->hInstance, sth_AboutTitle, Buffer, sizeof(Buffer) );
	strcat    ( Buffer, App->Name );

	//	Change title
	//
	SetCaption( Buffer );

	//	Handle version info
	//
	mh_ResourceText( Version, App->Name, VersionStr );

	//	Handle icon
	//
	if ( ( Icon = LoadIcon( App->hInstance, MakeIntRes(ico_About) ) ) != NULL ) {

		//	Change icon
        //
		SendDlgItemMessage( HWindow, idd_AboutIcon, STM_SETICON, (WPARAM)Icon, 0 );

		}
			
}

// ----eof about.cpp--------------------------------------------------------------------------
	