//      MHlist v2.0			Segment 1
//
//		ITEM.CPP			TMHItemDlg
//
//		(C)opyright 1992	by Matthias Hansen. Alle Rechte vorbehalten.
//
//
#pragma  option -zC_TEXT
#include "mhlist.h"
#pragma  hdrstop

#include "ico_sel.h"

// ---- TMHItemDlg ---------------------------------------------------------------------------
//	   ============
//
// ----Constructor----------------------------------------------------------------------------

TMHItemDlg::TMHItemDlg( PTMHGroup TheGroup, PTMHGroups TheGroups, int ATitle, PTWindowsObject AParent ) :TDialog(AParent,dlg_Item)
{
	char			Title[ 50 ];		//	Window title

	//	Init pointers
	//
	Group  = TheGroup;
	Groups = TheGroups;

	//	Associate controls
	//
    Description = new TEdit( this, idd_ItemDesc, 60 ); 

	//	New or existing group ?
	//
	if ( Group->GetText()[ 0 ] )
		NewGroup = FALSE;
	else
		NewGroup = TRUE;

	//	Load and set window title
	//
	LoadString( TheApp->hInstance, ATitle, Title, sizeof(Title) );
    SetCaption( Title );

}

// ----SetupWindow----------------------------------------------------------------------------

void TMHItemDlg::SetupWindow()
{

	//	Action
	//
	TDialog::SetupWindow();

	//	Center
	//
    mh_CenterPopup( HWindow, Parent->HWindow );

	//	Fill the edit control
	//
	Description->SetText( (char *)Group->GetText() );

	//	Display current icon
    //
	SendDlgItemMsg( idd_ItemIcon, STM_SETICON, WPARAM(Group->GetIcon()), 0 );

}

// ----Ok-------------------------------------------------------------------------------IDOK---
//
void TMHItemDlg::Ok( RTMessage Msg )
{
	char			TheDesc[ 60 ];
    int				Message = 0;		//	Assume success		


	//	Retrieve text
	//
	if ( !Description->GetText( TheDesc, sizeof(TheDesc) ) ) {

		//	Nothing entered
        //
		Message = sth_ItemDescEmpty;

		}
	else if ( NewGroup ) {

		//	Check for duplicates if new
		//
		if ( Groups->GetGroup( TheDesc ) != NOOBJECT )
			Message = sth_ItemDescDup;

		}

	//	Ok ?
	//
	if ( Message ) {

		//	Nope, inform user
		//
        //	***NYI***
		SetFocus  ( Description->HWindow  );
        return;

		}


	//	Save data
	//
	Group->SetText( TheDesc );

	//	Ok
	//
	TDialog::Ok(Msg);

}

// ----Browse------------------------------------------------------------idd_MergeEditBrowse---
//
void TMHItemDlg::Browse( RTMessage )
{
	char				File[ MAXPATH ];
	int					Pos;

	//	Retrieve data
	//
	Group->GetIconFile( File );
    Pos  = Group->GetIconPos(); 

	//	Search for new icon
	//
	if ( GetApplication()->ExecDialog( new TMHIconSelDlg( this, File, Pos ) ) == IDOK ) {

		//	Ok, save new icon
		//
		Group->SetIconData( File, Pos );

		//	Display it
		//
		SendDlgItemMsg( idd_ItemIcon, STM_SETICON, WPARAM(Group->GetIcon()), 0 );

		}

}

// ----eof ITEM.CPP----------------------------------------------------------------------------