//      MHlist v2.0			Segment 1
//
//		OD.CPP				OD base classes
//
//		(C)opyright 1992	by Matthias Hansen. Alle Rechte vorbehalten.
//
//
#pragma  option -zC_TEXT
#include "mhlist.h"
#pragma  hdrstop

// ---- TODSortedArray -----------------------------------------------------------------------
//     ================
//
static void AddItem    ( class Object _FAR & theObject, void *ListBox );

// ----Constructor----------------------------------------------------------------------------

TODSortedArray::TODSortedArray( int upper, int lower, sizeType aDelta )
			   :SortedArray   ( upper, lower, aDelta )
{

	//	Init data
	//
    ListBox = NULL;

}

// ----RegisterListBox------------------------------------------------------------------------

void TODSortedArray::RegisterListBox( PTODListBox TheListBox )
{

	//	Save pointer to listbox
	//
    ListBox = TheListBox;

}

// ----UnregisterListBox----------------------------------------------------------------------

void TODSortedArray::UnregisterListBox()
{

	//	Clear pointer to listbox
	//
    ListBox = NULL;

}

// ----add(Object&)---------------------------------------------------------------------------

void TODSortedArray::add( Object _FAR & toAdd )
{

	//	ListBox defined ?
	//
	if ( ListBox ) {

		//	Add to listbox
		//
		AddItem( toAdd, ListBox );

		}

	//	Add to array
	//
    SortedArray::add( toAdd );

}

// ----detach(int)----------------------------------------------------------------------------

void TODSortedArray::detach( int loc, DeleteType dt )
{

	//	ListBox defined ?
	//
	if ( ListBox ) {

		//	Detach from listbox
		//
		ListBox->DeleteString( loc );

		}

	//	Detach from array
	//
    AbstractArray::detach( loc, dt );

}

// ----detach(Object&)------------------------------------------------------------------------

void TODSortedArray::detach( Object _FAR & toDetach, DeleteType dt )
{

	//	ListBox defined ?
	//
	if ( ListBox ) {

		//	Detach from listbox
		//
		ListBox->DeleteString( find(toDetach) );

		}

	//	Detach from array
	//
    SortedArray::detach( toDetach, dt );

}

// ----AddItem----------------------------------------------------iterFunc to fill list box---

static void AddItem( class Object _FAR & theObject, void *ListBox )
{

	//	Add to listbox
    //
	PTODListBox(ListBox)->AddString( (char *)&theObject );

}

// ---- TMHODListBox -------------------------------------------------------------------------
//     ==============
//
// ----TODListBox---------------------------------------------------------------Constructor---

TODListBox::TODListBox( PTWindowsObject AParent, int ResourceId, PTModule AModule )
	       :TListBox  ( AParent, ResourceId, AModule)
{
	HDC					DC;
    TEXTMETRIC			TextMetric;

	//	Retrieve colors etc.
    //
	ColorHighlightText	= GetSysColor( COLOR_HIGHLIGHTTEXT );
	ColorHighlight		= GetSysColor( COLOR_HIGHLIGHT     );
	ColorWindowText		= GetSysColor( COLOR_BTNTEXT       );
	ColorWindow			= GetSysColor( COLOR_BTNFACE       );

	//	Determine height
	//	(We need to determine the height (if fixed) in the constructor, because
	//	HandleWMMeasureItem gets called before SetupWindow.) 
	//
	DC = GetDC         ( AParent->HWindow      );
		 GetTextMetrics( DC     , &TextMetric  );
	  	 ReleaseDC     ( AParent->HWindow,  DC );

	//	Save it
    //
	Height = TextMetric.tmHeight;

};

// ----HandleWMMeasureItem--------------------------------------------------------------------

void TODListBox::HandleWMMeasureItem( LPMEASUREITEMSTRUCT MIS )
{

	//	Set height
    //
	MIS->itemHeight = Height;

}

// ----HandleWMCompareItem--------------------------------------------------------------------

int TODListBox::HandleWMCompareItem( LPCOMPAREITEMSTRUCT CIS )
{
	PTODSortable		Item1 = PTODSortable(CIS->itemData1);
	PTODSortable		Item2 = PTODSortable(CIS->itemData2);

	//	Compare
    //
	if ( Item1->isLessThan( *Item2 ) )
		return -1;
    else if ( Item2->isLessThan( *Item1 ) )
		return -1;
	else
    	return  0;

}

// ----HandleWMDrawItem-----------------------------------------------------------------------

void TODListBox::HandleWMDrawItem( LPDRAWITEMSTRUCT DIS )
{
	PTODSortable		Item = PTODSortable(DIS->itemData);

	//	Handle Focus stuff
    //
	if ( DIS->itemAction & ODA_FOCUS ) {

		DrawFocusRect( DIS->hDC, &DIS->rcItem );
		return;

		}

	if ( DIS->itemState & ODA_SELECT ) {
	 
		DrawFocusRect( DIS->hDC, &DIS->rcItem );
		return;

		}

	//	Set colors
    //
	if ( DIS->itemState & ODS_SELECTED ) {

		SetTextColor( DIS->hDC, ColorHighlightText );
		SetBkColor  ( DIS->hDC, ColorHighlight     );

		} 
	else {

		SetTextColor( DIS->hDC, ColorWindowText );
		SetBkColor  ( DIS->hDC, ColorWindow     );

		}

	//	Display text
    //
    Display( DIS, Item );

	//	Draw focus rectangle
    //
  	if ( DIS->itemState & ODS_FOCUS )
		DrawFocusRect( DIS->hDC, &DIS->rcItem );

}

// ----Display--------------------------------------------------------------------------------

void TODListBox::Display( LPDRAWITEMSTRUCT DIS, PTODSortable Item )
{

	//	Display text
    //
	ExtTextOut( DIS->hDC
			  , DIS->rcItem.left
			  , DIS->rcItem.top
			  , ETO_OPAQUE
			  , &(DIS->rcItem)
			  , Item->GetText()
			  , strlen(Item->GetText())
			  , NULL
			  );
}

// ----eof OD.CPP-----------------------------------------------------------------------------