//      MHlist v2.0			Segment 1
//
//		WINDOW.CPP			Window handling
//
//		(C)opyright 1991,92	by Matthias Hansen. Alle Rechte vorbehalten.
//
//
#pragma  option -zC_TEXT
#include "mhlist.h"
#pragma  hdrstop

// ----mh_CenterPopup---------------------------------------------------Center popup window---
//
//	Arguments:
//
//    hWnd              	Window handle
//    hParentWnd = NULL		Parent window handle (default is to center on the screen)
//
void _FAR _EXPFUNC mh_CenterPopup( HWND hWnd, HWND hParentWnd )
{
	RECT     				Rect;
	int      				xPopup,
							yPopup,
							cxPopup,
							cyPopup,
							cxScreen,
							cyScreen;

   //	Retrieve main display dimensions
   //
   cxScreen = GetSystemMetrics( SM_CXSCREEN );
   cyScreen = GetSystemMetrics( SM_CYSCREEN );

   //	Retrieve popup rectangle
   //
   GetWindowRect( hWnd, &Rect );

   //	Calculate popup extents
   //
   cxPopup = Rect.right  - Rect.left;
   cyPopup = Rect.bottom - Rect.top;

   //	Calculate bounding rectangle
   //
   if ( hParentWnd ) {

		int				cxParent,
						cyParent;

		//	Retrieve parent rectangle
		//
		GetWindowRect( hParentWnd, &Rect );

		//	Calculate parent extents
		//
		cxParent = Rect.right  - Rect.left;
		cyParent = Rect.bottom - Rect.top;

		//	Center within parent window
		//
		xPopup = Rect.left + ((cxParent - cxPopup) /2);
		yPopup = Rect.top  + ((cyParent - cyPopup) /2);

		//	Adjust popup x-location for screen size
		//
		if ( xPopup+cxPopup > cxScreen )
			xPopup = cxScreen - cxPopup;

		//	Adjust popup y-location for screen size
		//
		if ( yPopup+cyPopup > cyScreen )
			yPopup = cyScreen - cyPopup;

		}
	else {

		//	Center within entire screen
		//
		xPopup = (cxScreen - cxPopup) / 2;
		yPopup = (cyScreen - cyPopup) / 2;

		}

   //	Move window to new location & display
   //
   MoveWindow( hWnd
			 , ( xPopup > 0 ) ? xPopup : 0
			 , ( yPopup > 0 ) ? yPopup : 0
			 , cxPopup
			 , cyPopup
			 , TRUE
			 );

}

// ----eof WINDOW.CPP--------------------------------------------------------------------------